program project1;

{$IFDEF FPC}
{$mode delphi}
{$ENDIF}

{$IFNDEF FPC}
uses
  Winapi.Windows;

type
  TLibHandle = THandle;

const
  NilHandle = 0;
{$ENDIF}

var
  FmtStr: function(const fmt: PAnsiChar): PAnsiChar; cdecl; varargs;
  Handle: TLibHandle;
begin
  Handle := LoadLibrary('./libmyfunc.dll');
  try
    if Handle > NilHandle then
    begin
      FmtStr := GetProcAddress(Handle, 'fmtstr');
      if Assigned(FmtStr) then
        WriteLn(FmtStr('Foo: %s', 'Bar'))
      else
        WriteLn('Fail');
    end
    else
      WriteLn('Fail');
    WriteLn;
    WriteLn('Press [ENTER] to exit ...');
    ReadLn;
  finally
    if Handle > NilHandle then
      FreeLibrary(Handle);
  end;
end.

